export class SoundInstance extends MessageDispatcher {
    constructor(sound: SoundClip);
    private mId;
    private mSound;
    private mState;
    private mChannel;
    private mVolume;
    private mLoop;
    private mStartTime;
    private mPausePosition;
    private mStopPosition;
    private mSrc;
    private mGainNode;
    private mFirstNode;
    private mPlayNode;
    private mSpatialPanner;
    private mStereoPanner;
    private mAnalyser;
    enableSpacePan(): PannerNode;
    enableStereoPan(): StereoPanner;
    enableAnalyser(): AnalyserNode;
    private __reconnectSource;
    _play(): SoundInstance;
    stop(duration?: number): void;
    pause(): void;
    resume(): void;
    fade(from: number, to: number, duration?: number, type?: string): void;
    private __onComplete;
    get currentPosition(): number;
    get _outputNode(): AudioNode;
    set channel(arg: string);
    get channel(): string;
    set volume(arg: number);
    get volume(): number;
    set loop(arg: boolean);
    get loop(): boolean;
    set pan(arg: number);
    get pan(): number;
    get isPlaying(): boolean;
    get duration(): number;
}
import { MessageDispatcher } from '../messages/MessageDispatcher';
import { StereoPanner } from './effects/StereoPanner';
import { SoundClip } from './SoundClip';
